<?php
namespace OrganizationsManagement\Factory;

use OrganizationsManagement\Util\InstanceProvider;
use Teknisa\Model\Teknisa\Entities\Contratolinp;
use Teknisa\Model\Teknisa\Entities\Sistcontlinp;

class LinhaProduto {

    public function insertContratoLinp($dateNow, $orgId, $codOperador, $nrproposfas, $nrverpropfas, $cdcliente,
                                       $cdlinpclie, $cdlinpclieinfor, $nmlinpclie, $idtiplinpc, $qtminimafatlinp,
                                       $nrusualinpc, $idamblinpc, $idmproclinpc, $idlproclinpc, $productId, $contractCode) {
        $contratolinp = new Contratolinp();

        $contratolinp->setNrproposfas($nrproposfas);
        $contratolinp->setNrverpropfas($nrverpropfas);
        $contratolinp->setCdcliente($cdcliente);
        $contratolinp->setCdlinpclie($cdlinpclie);
        $contratolinp->setCdlinpclieinfor($cdlinpclieinfor);
        $contratolinp->setNmlinpclie($nmlinpclie);
        $contratolinp->setIdtiplinpc($idtiplinpc);
        $contratolinp->setQtminimafatlinp($qtminimafatlinp);
        $contratolinp->setNrusualinpc($nrusualinpc);
        $contratolinp->setIdamblinpc($idamblinpc);
        $contratolinp->setIdmproclinpc($idmproclinpc);
        $contratolinp->setIdlproclinpc($idlproclinpc);
        $contratolinp->setIdbloqlinp('N');
        $contratolinp->setNrprodutoId($productId);
        $contratolinp->setNrseqcontrato($contractCode);

        $contratolinp->setNrorg($orgId);
        $contratolinp->setNrorginclusao($orgId);
        $contratolinp->setNrorgultatu($orgId);
        $contratolinp->setDtinclusao($dateNow);
        $contratolinp->setDtultatu($dateNow);
        $contratolinp->setCdoperinclusao($codOperador);
        $contratolinp->setCdoperultatu($codOperador);

        return $contratolinp;
    }

    public function insertSistContLinp($dateNow, $orgId, $codOperador, $cdcliente, $cdlinpclie, $cdsistema) {
        /** @var $sistcontlinp Sistcontlinp */
        $sistcontlinp = new Sistcontlinp();

        $sistcontlinp->setCdcliente($cdcliente);
        $sistcontlinp->setCdlinpclie($cdlinpclie);
        $sistcontlinp->setCdsistema($cdsistema);
        $sistcontlinp->setNrorg($orgId);

        $sistcontlinp->setNrorg($orgId);
        $sistcontlinp->setNrorginclusao($orgId);
        $sistcontlinp->setNrorgultatu($orgId);
        $sistcontlinp->setDtinclusao($dateNow);
        $sistcontlinp->setDtultatu($dateNow);
        $sistcontlinp->setCdoperinclusao($codOperador);
        $sistcontlinp->setCdoperultatu($codOperador);

        return $sistcontlinp;
    }

    public function insertValorlinp($orgId, $codOperador, $cdcliente, $cdlinpclie, $dtivigvrlinp,
                                    $dtfvigvrlinp, $vrlicencusolinp, $vrmensalidalinp) {

        $query = "INSERT INTO VALORLINP
                         (NRORG, NRORGINCLUSAO, DTINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, DTULTATU, CDOPERULTATU,
                          CDCLIENTE, CDLINPCLIE, VRLICENCUSOLINP, VRMENSALIDALINP, DTIVIGVRLINP, DTFVIGVRLINP)
                  VALUES (:NRORG, :NRORG, SYSDATE, :CDOPERADOR, :NRORG, SYSDATE, :CDOPERADOR,
                          :CDCLIENTE, :CDLINPCLIE, :VRLICENCUSOLINP, :VRMENSALIDALINP, 
                          TRUNC(TO_DATE(:DTIVIGVRLINP, 'DD/MM/YYYY')), TRUNC(TO_DATE(:DTFVIGVRLINP, 'DD/MM/YYYY')))";

        $params = array(
            'CDOPERADOR'        => $codOperador,
            'NRORG'             => $orgId,
            'CDCLIENTE'         => $cdcliente,
            'CDLINPCLIE'        => $cdlinpclie,
            'DTIVIGVRLINP'      => $dtivigvrlinp,
            'DTFVIGVRLINP'      => $dtfvigvrlinp,
            'VRLICENCUSOLINP'   => $vrlicencusolinp,
            'VRMENSALIDALINP'   => $vrmensalidalinp,
        );

        $stm = InstanceProvider::getEntityManager()->getConnection()->prepare($query);
        $stm->execute($params);
    }

    public function updateValorlinp($orgId, $codOperador, $cdcliente, $cdlinpclie, $dtivigvrlinp,
                                    $dtfvigvrlinp, $vrlicencusolinp, $vrmensalidalinp) {

        $query = "UPDATE VALORLINP
                     SET VRLICENCUSOLINP = :VRLICENCUSOLINP, 
                         VRMENSALIDALINP = :VRMENSALIDALINP, 
                         DTIVIGVRLINP    = TRUNC(TO_DATE(:DTIVIGVRLINP, 'DD/MM/YYYY')), 
                         DTFVIGVRLINP    = TRUNC(TO_DATE(:DTFVIGVRLINP, 'DD/MM/YYYY')),
                         NRORGULTATU     = :NRORG,
                         DTULTATU        = SYSDATE,
                         CDOPERULTATU    = :CDOPERADOR
                   WHERE CDCLIENTE    = :CDCLIENTE
                     AND CDLINPCLIE   = :CDLINPCLIE
                     AND DTIVIGVRLINP = TRUNC(TO_DATE(:DTIVIGVRLINP, 'DD/MM/YYYY'))";

        $params = array(
            'CDOPERADOR'        => $codOperador,
            'NRORG'             => $orgId,
            'CDCLIENTE'         => $cdcliente,
            'CDLINPCLIE'        => $cdlinpclie,
            'DTIVIGVRLINP'      => $dtivigvrlinp,
            'DTFVIGVRLINP'      => $dtfvigvrlinp,
            'VRLICENCUSOLINP'   => $vrlicencusolinp,
            'VRMENSALIDALINP'   => $vrmensalidalinp,
        );

        $stm = InstanceProvider::getEntityManager()->getConnection()->prepare($query);
        $stm->execute($params);
    }
}