<?php
namespace OrganizationsManagement\Service;

use OrganizationsManagement\Util\Instance;
use OrganizationsManagement\Util\InstanceProvider;
use OrganizationsManagement\Util\Utilities;
use Teknisa\Model\Teknisa\Entities\Base\Moticont;

class CRMIntegration
{
    public function getClassificationRelationship($page, $pageSize, $filters)
    {
        $limit = $page * $pageSize;
        $offset = ($page - 1) * $pageSize;
        $conditions = Utilities::createQueryFiltered($filters);
        $classificationRelationship = Instance\Repository::getMoticont()
            ->getClassificationRelationship($conditions, $limit, $offset);
        return $classificationRelationship;
    }

    public function getClassificationGep($page, $pageSize, $filters)
    {
        $limit = $page * $pageSize;
        $offset = ($page - 1) * $pageSize;
        $conditions = Utilities::createQueryFiltered($filters);
        $classificationRelationship = Instance\Repository::getAssunto()
            ->getClassificationGep($conditions, $limit, $offset);
        return $classificationRelationship;
    }

    public function getClassificationPM($page, $pageSize, $filters)
    {
        $limit = $page * $pageSize;
        $offset = ($page - 1) * $pageSize;
        $conditions = Utilities::createQueryFiltered($filters);
        $classificationRelationship = Instance\Repository::getAssunto()
            ->getClassificationPM($conditions, $limit, $offset);
        return $classificationRelationship;
    }

    public function classificationRelationshipSave($cdmoticont,$cdassunto,$classificationId)
    {
        $entityManager = InstanceProvider::getEntityManager();
        /** @var Moticont $moticont */
        $moticont = Instance\Repository::getMoticont()->findOneBy(array('cdmoticont' => $cdmoticont));
        $moticont->setCdassunto($cdassunto);
        $moticont->setClassificationId($classificationId);
        $entityManager->persist($moticont);
        $entityManager->flush();
        return $cdmoticont;
    }
}