/**
 * Retorna o custo de um produto existente no cardápio de trabalho
 * @param {Number} P_NRCARDAPIOTRAB Número do cardápio de trabalho de origem
 * @param {Varchar2} P_CDPRODUTO Código do produto
 */
CREATE OR REPLACE FUNCTION CUSTO_PROD_CARDTRAB
(
   P_NRCARDAPIOTRAB IN NUMBER,
   P_CDPRODUTO IN VARCHAR2
) RETURN FLOAT
AS
   V_VRCUSTO FLOAT := 0;
BEGIN
   SELECT MAX(VRCUSTO)
     INTO V_VRCUSTO
     FROM PRODUTOCARDTRAB
    WHERE NRCARDAPIOTRAB = P_NRCARDAPIOTRAB
      AND CDPRODUTO = P_CDPRODUTO;

   RETURN ROUND(NVL(V_VRCUSTO, 0.00), 5);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CUSTO_PROD_CARDTRAB','6.35.009'); END;
/
